
## Development

```sh
git clone git@github.com:thingdom/node-neo4j.git
cd node-neo4j
npm install && npm run clean
```

You'll need a local installation of Neo4j ([links](http://neo4j.org/download)), and it should be running on the default port of 7474 (`neo4j start`).

To run the tests:

```sh
npm test
```

This library is written in [CoffeeScript](http://coffeescript.org/). The tests automatically compile the code on-the-fly, but you can also generate compiled `.js` files from the source `.coffee` files manually:

```sh
npm run build
```

This is in fact what's run on `prepublish` for npm. But please don't check the generated `.js` files in; to remove:

```sh
npm run clean
```

When compiled `.js` files exist, changes to the source `.coffee` files will *not* be picked up automatically; you'll need to rebuild.

If you `npm link` this module and you want the code compiled on-the-fly during development, you can create an `exports.js` file under `lib-new/` with the following:

```js
require('coffee-script/register');
module.exports = require('./exports.coffee');
```

But don't check this in! That would cause all clients to compile the code on-the-fly every time, which isn't desirable in production.
